Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.queryParser
Class QueryParser

    java.lang.Object
      org.apache.lucene.queryParser.QueryParser

All Implemented Interfaces:
  QueryParserConstants

Direct Known Subclasses:
  MultiFieldQueryParser

public class QueryParser
extends Object
implements QueryParserConstants

This class is generated by JavaCC. The only method that clients should need to call is parse(). The syntax for query strings is as follows: A Query is a series of clauses. A clause may be prefixed by:

- a plus (`+`) or a minus (`-`) sign, indicating that the clause is required or prohibited respectively; or
- a term followed by a colon, indicating the field to be searched. This enables one to construct queries which search multiple fields.

A clause may be either:

- a term, indicating all the documents that contain this term; or
- a nested query, enclosed in parentheses. Note that this may be used with a `+`/`-` prefix to require any of a set of terms.

Thus, in BNF, the query grammar is:

       Query  ::= ( Clause )*
       Clause ::= ["+", "-"] [<TERM> ":"] ( <TERM> | "(" Query ")" )

Examples of appropriately formatted queries can be found in the test cases.

Author:
  Brian Goetz, Peter Halacsy, Tatu Saloranta

Field Summary
`static int` | `DEFAULT_OPERATOR_AND`
`static int` | `DEFAULT_OPERATOR_OR`
`Token` | `jj_nt`
`boolean` | `lookingAhead`
`Token` | `token`
`QueryParserTokenManager` | `token_source`

Fields inherited from interface org.apache.lucene.queryParser.QueryParserConstants
`_ESCAPED_CHAR, _NUM_CHAR, _TERM_CHAR, _TERM_START_CHAR, _WHITESPACE, AND, Boost, CARAT, COLON, DEFAULT, EOF, FUZZY_SLOP, LPAREN, MINUS, NOT, NUMBER, OR, PLUS, PREFIXTERM, QUOTED, RangeEx, RANGEEX_END, RANGEEX_GOOP, RANGEEX_QUOTED, RANGEEX_START, RANGEEX_TO, RangeIn, RANGEIN_END, RANGEIN_GOOP, RANGEIN_QUOTED, RANGEIN_START, RANGEIN_TO, RPAREN, TERM, tokenImage, WILDTERM`

Constructor Summary
`QueryParser(CharStream stream)`
`QueryParser(QueryParserTokenManager tm)`
`QueryParser(String f, Analyzer a)` Constructs a query parser.

Method Summary
`protected void` | `addClause(Vector clauses, int conj, int mods, Query q)`
`Query` | `Clause(String field)`
`int` | `Conjunction()`
`void` | `disable_tracing()`
`void` | `enable_tracing()`
`static String` | `escape(String s)` Returns a String where those characters that QueryParser expects to be escaped are escaped, i.e. preceded by a `\`.
`ParseException` | `generateParseException()`
`Analyzer` | `getAnalyzer()`
`protected Query` | `getBooleanQuery(Vector clauses)` Factory method for generating query, given a set of clauses.
`String` | `getField()`
`protected Query` | `getFieldQuery(String field, Analyzer analyzer, String queryText)` Note that parameter analyzer is ignored.
`protected Query` | `getFieldQuery(String field, Analyzer analyzer, String queryText, int slop)` Base implementation delegates to `getFieldQuery(String, Analyzer, String)`.
`protected Query` | `getFieldQuery(String field, String queryText)`
`protected Query` | `getFieldQuery(String field, String queryText, int slop)` Base implementation delegates to `getFieldQuery(String,String)`.
`float` | `getFuzzyMinSim()` Get the default minimal similarity for fuzzy queries.
`protected Query` | `getFuzzyQuery(String field, String termStr)` Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`).
`protected Query` | `getFuzzyQuery(String field, String termStr, float minSimilarity)` Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`).
`Locale` | `getLocale()` Returns current locale, allowing access by subclasses.
`boolean` | `getLowercaseWildcardTerms()`
`Token` | `getNextToken()`
`int` | `getOperator()` Gets implicit operator setting, which will be either DEFAULT_OPERATOR_AND or DEFAULT_OPERATOR_OR.
`int` | `getPhraseSlop()` Gets the default slop for phrases.
`protected Query` | `getPrefixQuery(String field, String termStr)` Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`).
`protected Query` | `getRangeQuery(String field, Analyzer analyzer, String part1, String part2, boolean inclusive)` Note that parameter analyzer is ignored.
`protected Query` | `getRangeQuery(String field, String part1, String part2, boolean inclusive)`
`Token` | `getToken(int index)`
`protected Query` | `getWildcardQuery(String field, String termStr)` Factory method for generating a query.
`static void` | `main(String[] args)`
`int` | `Modifiers()`
`Query` | `parse(String query)` Parses a query string, returning a Query.
`static Query` | `parse(String query, String field, Analyzer analyzer)` Parses a query string, returning a `Query`.
`Query` | `Query(String field)`
`void` | `ReInit(CharStream stream)`
`void` | `ReInit(QueryParserTokenManager tm)`
`void` | `setFuzzyMinSim(float fuzzyMinSim)` Set the default minimum similarity for fuzzy queries.
`void` | `setLocale(Locale locale)` Set locale used by date range parsing.
`void` | `setLowercaseWildcardTerms(boolean lowercaseWildcardTerms)`
`void` | `setOperator(int operator)` Sets the boolean operator of the QueryParser.
`void` | `setPhraseSlop(int phraseSlop)` Sets the default slop for phrases.
`Query` | `Term(String field)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_OPERATOR_OR

    public static final int DEFAULT_OPERATOR_OR

See Also:
  Constant Field Values

### DEFAULT_OPERATOR_AND

    public static final int DEFAULT_OPERATOR_AND

See Also:
  Constant Field Values

### token_source

    public QueryParserTokenManager token_source

### token

    public Token token

### jj_nt

    public Token jj_nt

### lookingAhead

    public boolean lookingAhead

Constructor Detail

### QueryParser

    public QueryParser(String f,
                       Analyzer a)

  Constructs a query parser.

Parameters:
  `f` - the default field for query terms.
  `a` - used to find terms in the query text.

### QueryParser

    public QueryParser(CharStream stream)

### QueryParser

    public QueryParser(QueryParserTokenManager tm)

Method Detail

### parse

    public static Query parse(String query,
                              String field,
                              Analyzer analyzer)
                       throws ParseException

  Parses a query string, returning a `Query`.

  Parameters:
    `query` - the query string to be parsed.
    `field` - the default field for query terms.
    `analyzer` - used to find terms in the query text.
  Throws:
    `ParseException` - if the parsing fails

### parse

    public Query parse(String query)
                throws ParseException

  Parses a query string, returning a Query.

  Parameters:
    `query` - the query string to be parsed.
  Throws:
    `ParseException` - if the parsing fails

### getAnalyzer

    public Analyzer getAnalyzer()

  Returns:
    Returns the analyzer.

### getField

    public String getField()

  Returns:
    Returns the field.

### getFuzzyMinSim

    public float getFuzzyMinSim()

  Get the default minimal similarity for fuzzy queries.

### setFuzzyMinSim

    public void setFuzzyMinSim(float fuzzyMinSim)

  Set the default minimum similarity for fuzzy queries.

### setPhraseSlop

    public void setPhraseSlop(int phraseSlop)

  Sets the default slop for phrases. If zero, then exact phrase matches are required. Default value is zero.

### getPhraseSlop

    public int getPhraseSlop()

  Gets the default slop for phrases.

### setOperator

    public void setOperator(int operator)

  Sets the boolean operator of the QueryParser. In classic mode (`DEFAULT_OPERATOR_OR`) terms without any modifiers are considered optional: for example `capital of Hungary` is equal to `capital OR of OR Hungary`.
  In `DEFAULT_OPERATOR_AND` terms are considered to be in conjuction: the above mentioned query is parsed as `capital AND of AND Hungary`

### getOperator

    public int getOperator()

  Gets implicit operator setting, which will be either DEFAULT_OPERATOR_AND or DEFAULT_OPERATOR_OR.

### setLowercaseWildcardTerms

    public void setLowercaseWildcardTerms(boolean lowercaseWildcardTerms)

### getLowercaseWildcardTerms

    public boolean getLowercaseWildcardTerms()

### setLocale

    public void setLocale(Locale locale)

  Set locale used by date range parsing.

### getLocale

    public Locale getLocale()

  Returns current locale, allowing access by subclasses.

### addClause

    protected void addClause(Vector clauses,
                             int conj,
                             int mods,
                             Query q)

### getFieldQuery

    protected Query getFieldQuery(String field,
                                  Analyzer analyzer,
                                  String queryText)
                           throws ParseException

  Note that parameter analyzer is ignored. Calls inside the parser always use class member analyser. This method will be deprecated and substituted by `getFieldQuery(String, String)` in future versions of Lucene. Currently overwriting either of these methods works.

  Throws:
    `ParseException` - throw in overridden method to disallow

### getFieldQuery

    protected Query getFieldQuery(String field,
                                  String queryText)
                           throws ParseException

  Throws:
    `ParseException` - throw in overridden method to disallow

### getFieldQuery

    protected Query getFieldQuery(String field,
                                  Analyzer analyzer,
                                  String queryText,
                                  int slop)
                           throws ParseException

  Base implementation delegates to `getFieldQuery(String, Analyzer, String)`. This method may be overwritten, for example, to return a SpanNearQuery instead of a PhraseQuery. Note that parameter analyzer is ignored. Calls inside the parser always use class member analyser. This method will be deprecated and substituted by `getFieldQuery(String, String, int)` in future versions of Lucene. Currently overwriting either of these methods works.

  Throws:
    `ParseException` - throw in overridden method to disallow

### getFieldQuery

    protected Query getFieldQuery(String field,
                                  String queryText,
                                  int slop)
                           throws ParseException

  Base implementation delegates to `getFieldQuery(String,String)`. This method may be overridden, for example, to return a SpanNearQuery instead of a PhraseQuery.

  Throws:
    `ParseException` - throw in overridden method to disallow

### getRangeQuery

    protected Query getRangeQuery(String field,
                                  Analyzer analyzer,
                                  String part1,
                                  String part2,
                                  boolean inclusive)
                           throws ParseException

  Note that parameter analyzer is ignored. Calls inside the parser always use class member analyser. This method will be deprecated and substituted by `getRangeQuery(String, String, String, boolean)` in future versions of Lucene. Currently overwriting either of these methods works.

  Throws:
    `ParseException` - throw in overridden method to disallow

### getRangeQuery

    protected Query getRangeQuery(String field,
                                  String part1,
                                  String part2,
                                  boolean inclusive)
                           throws ParseException

  Throws:
    `ParseException` - throw in overridden method to disallow

### getBooleanQuery

    protected Query getBooleanQuery(Vector clauses)
                             throws ParseException

  Factory method for generating query, given a set of clauses. By default creates a boolean query composed of clauses passed in. Can be overridden by extending classes, to modify query being returned.

  Parameters:
    `clauses` - Vector that contains `BooleanClause` instances to join.
  Returns:
    Resulting `Query` object.
  Throws:
    `ParseException` - throw in overridden method to disallow

### getWildcardQuery

    protected Query getWildcardQuery(String field,
                                     String termStr)
                              throws ParseException

  Factory method for generating a query. Called when parser parses an input term token that contains one or more wildcard characters (? and *), but is not a prefix term token (one that has just a single * character at the end)

  Depending on settings, prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

  Can be overridden by extending classes, to provide custom handling for wildcard queries, which may be necessary due to missing analyzer calls.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token that contains one or more wild card characters (? or *), but is not simple prefix term
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### getPrefixQuery

    protected Query getPrefixQuery(String field,
                                   String termStr)
                            throws ParseException

  Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that uses prefix notation; that is, contains a single '*' wildcard character as its last character. Since this is a special case of generic wildcard term, and such a query can be optimized easily, this usually results in a different query object.

  Depending on settings, a prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

  Can be overridden by extending classes, to provide custom handling for wild card queries, which may be necessary due to missing analyzer calls.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token to use for building term for the query (without trailing '*' character!)
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### getFuzzyQuery

    protected Query getFuzzyQuery(String field,
                                  String termStr)
                           throws ParseException

  Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that has the fuzzy suffix (~) appended.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token to use for building term for the query
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### getFuzzyQuery

    protected Query getFuzzyQuery(String field,
                                  String termStr,
                                  float minSimilarity)
                           throws ParseException

  Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that has the fuzzy suffix (~floatNumber) appended.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token to use for building term for the query
    `minSimilarity` - the minimum similarity required for a fuzzy match
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### escape

    public static String escape(String s)

  Returns a String where those characters that QueryParser expects to be escaped are escaped, i.e. preceded by a `\`.

### main

    public static void main(String[] args)
                     throws Exception

  Throws:
    `Exception`

### Conjunction

    public final int Conjunction()
                          throws ParseException

  Throws:
    `ParseException`

### Modifiers

    public final int Modifiers()
                        throws ParseException

  Throws:
    `ParseException`

### Query

    public final Query Query(String field)
                      throws ParseException

  Throws:
    `ParseException`

### Clause

    public final Query Clause(String field)
                       throws ParseException

  Throws:
    `ParseException`

### Term

    public final Query Term(String field)
                     throws ParseException

  Throws:
    `ParseException`

### ReInit

    public void ReInit(CharStream stream)

### ReInit

    public void ReInit(QueryParserTokenManager tm)

### getNextToken

    public final Token getNextToken()

### getToken

    public final Token getToken(int index)

### generateParseException

    public ParseException generateParseException()

### enable_tracing

    public final void enable_tracing()

### disable_tracing

    public final void disable_tracing()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2005 Apache Software Foundation. All Rights Reserved.